//------------------------------ $Keywords ----------------------------------
// SelfImage - Windows disk image backup
// SelfImage_MainForm.cpp - Main form header
// Copyright 2005, Kurt Fitzner <kfitzner@excelcia.org>
//---------------------------------------------------------------------------
// This file is part of SelfImage.
//
// SelfImage is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SelfImage is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
//---------------------------------------------------------------------------
#ifndef SelfImage_MainFormH
#define SelfImage_MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Mask.hpp>
#include <StdCtrls.hpp>
#include "JvBevel.hpp"
#include "JvCombobox.hpp"
#include "JvComponent.hpp"
#include "JvDriveCtrls.hpp"
#include "JvExControls.hpp"
#include "JvExExtCtrls.hpp"
#include "JvExMask.hpp"
#include "JvExStdCtrls.hpp"
#include "JvSpecialProgress.hpp"
#include "JvToolEdit.hpp"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
enum TMainFormVisualMode { modeSetup, modeOperating };
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
  TGroupBox *gbInput;
  TLabel *lblSourceDrive;
  TLabel *lblSectorSize;
  TLabel *lblSectorSizeValue;
  TLabel *lblSectorCount;
  TLabel *lblSectorCountValue;
  TLabel *lblTotalSize;
  TLabel *lblTotalSizeValue;
  TGroupBox *gbOutput;
  TJvFilenameEdit *edtTargetFile;
  TButton *btnOk;
  TButton *btnCancel;
  TGroupBox *gbStatus;
  TJvSpecialProgress *ProgressBar;
  TJvBevel *ProgressBarBevel;
  TLabel *lblBytesWritten;
  TLabel *lblBytesTotal;
  TLabel *lblBytesWrittenValue;
  TLabel *lblBytesTotalValue;
  TLabel *lblWriteSpeedValue;
  TLabel *lblWriteSpeed;
  TLabel *lblOverallSpeed;
  TLabel *lblOverallSpeedValue;
  TComboBox *cmbDriveList;

  void __fastcall FormShow(TObject *Sender);
  void __fastcall btnOkClick(TObject *Sender);
  void __fastcall btnCancelClick(TObject *Sender);
  void __fastcall cmbSourceDriveChange(TObject *Sender);
  void __fastcall edtTargetFileChange(TObject *Sender);

private:	// User declarations
  TList *DriveList;
  DWORD nBytesPerSector, nSectorsPerTrack;
  unsigned __int64 nnTotalBytes;
  bool bCancelOperation;
  ULARGE_INTEGER BytesWrittenTotal, BytesReadTotal;

  void __fastcall UpdateDriveInfo(void);
  void __fastcall VisualMode(TMainFormVisualMode Mode);
  void __fastcall UpdateStatus(bool bInit = false);

public:		// User declarations
  __fastcall TMainForm(TComponent* Owner);

};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
